{$R+}
Program h; uses dos;

 const n256:longint=256;
 var b:file of byte;
 var n1,n2,n3,n4:byte; v2:word; v4:longint;
 var ppp,ppp0:longint;
 var ss,sss:longint;
 var c4:array[1..4] of char absolute ss;
 var b4:array[1..4] of byte absolute ss;
 const s_fmt :array[1..4] of char=('f','m','t',' ');
       s_fact:array[1..4] of char=('f','a','c','t');
       s_data:array[1..4] of char=('d','a','t','a');
 var Samp_Sec,Bajt_Sec:longint;
 label ende;

 procedure ust0(sme:longint); begin seek(b,sme); end;

 type s2=string[2]; s4=string[4]; s8=string[8];
 function sb(c:byte):s2;
  const s:array[0..15] of char='0123456789ABCDEF';
 begin sb:=s[c div 16]+s[c mod 16]; end;
 function sw(c:word):s4;
 begin sw:=sb(hi(c))+sb(lo(c)); end;

 function sl(c:longint):s8;
  const a:longint=65536;
  var ss:s8;
  var w:array[1..2] of word; cc:longint absolute w;
 begin cc:=c; ss:=sw(w[2])+sw(w[1]); sl:=ss; end;

 function h1(sme:longint):byte; var n1:byte;
 begin
  ust0(sme); read(b,n1); h1:=n1;
 end;
 function h2(sme:longint):word; const l1:longint=1; var n1,n2:byte;
 begin
  ust0(sme); read(b,n1,n2); 
  h2:=l1*n2*256+n1;
 end;
 function h4(sme:longint):longint; const l1:longint=1; var n1,n2,n3,n4:byte;
 begin
  ust0(sme); read(b,n1,n2,n3,n4);
  {writeln('h4: ',sl(sme),' ',sb(n1),' ',sb(n2),' ',sb(n3),' ',sb(n4));}
  h4:=((l1*n4*256+n3)*256+n2)*256+n1;
 end;

 function obrc(c:byte):char; var c1:char;
 begin
  if (c<$20) or (c>=$FF) then c1:='.' else c1:=chr(c); obrc:=c1;
 end;

 procedure izobr(base,sme:longint; typ:byte; comment:string);
  const l1:longint=1; {n1..n4,v2,v4 - v gol. prog. dl`a posled. ispol`z.}
 begin
  write(sl(base),' ',sl(sme),' ',sl(base+sme),' ');
  ust0(base+sme);
  case typ of
   1: begin
         read(b,n1);
         write('      ',sb(n1),'    ',obrc(n1),' ',n1:9);
        end;
   2: begin
         read(b,n1,n2); v2:=l1*n2*256+n1;
         write('    ',{sw(v2),}sb(n1),sb(n2),'   ',obrc(n1),obrc(n2),' ',v2:9);
        end;
   4: begin
         read(b,n1,n2,n3,n4); v4:=((l1*n4*256+n3)*256+n2)*256+n1;
         write({sl(v4),}sb(n1),sb(n2),sb(n3),sb(n4),' ',
           obrc(n1),obrc(n2),obrc(n3),obrc(n4),' ',v4:9);
        end;
   else begin write('typ=',typ,' - ?; '); end;
  end {case};
  writeln(' ',comment);
 end;

 procedure show_fmt(ppp0:longint);
  var i:integer; w:word; il,sss:longint;
 begin
  sss:=h4(ppp0+4); if sss<>$10 then for i:=1 to sss div 4 do begin
   ss:=h4(ppp0+8+4*(i-1));
   writeln(obrc(b4[1]),obrc(b4[2]),obrc(b4[3]),obrc(b4[4]),' ',sl(ss));
  end;
  w:=h2(ppp0+8);  writeln(sw(w),' - wFormatTag (tipichno 1 - oscillogramma)');
  w:=h2(ppp0+10); writeln(sw(w),' - wChannels (1 - mono, 2 - stereo)');
  il:=h4(ppp0+12); writeln(sl(il),' ',il:8,' - dwSamplesPerSec');
  Samp_Sec:=il;
  il:=h4(ppp0+16); writeln(sl(il),' ',il:8,' - dwBytesPerSec');
  Bajt_Sec:=il;
  w:=h2(ppp0+20); writeln(sw(w),' - wBlockAlign (tipichno 1)');
  w:=h2(ppp0+22); writeln(sw(w),' - wBitsPerSample (8 - pobajtno)');
 end;

 procedure show_fact(ppp0:longint);
  var i:integer; sss:longint;
 begin
  writeln(' (istinn. chislo tochek dlq upawannyh *.vaw)');
  sss:=h4(ppp0+4); for i:=1 to sss div 4 do begin
   ss:=h4(ppp0+8+4*(i-1));
   writeln(obrc(b4[1]),obrc(b4[2]),obrc(b4[3]),obrc(b4[4]),' ',sl(ss));
  end;
 end;

 procedure show_data(ppp0:longint);
  var sss:longint;
 begin
  sss:=h4(ppp0+4);
  writeln('chislo tochek, dlit. w sek. = ',sss:8,' ',sss/Bajt_Sec:10:4);
 end;

 procedure show_xxx(ppp0:longint); var c:byte; i:integer;
 begin
  ust0(ppp0+8);
  for i:=1 to 64 do if not eof(b) then begin
   read(b,c); write(obrc(c));
  end; writeln;
 end;

Begin writeln;
 if (paramcount<>1) then begin
  writeln('Obr.: prog infile .'); halt;
 end;
 writeln;
 writeln('                  ',paramstr(1):12,' ');
 writeln;
 Assign(b,ParamStr(1));
 filemode:=0; {inache ne otkr. fajly s atrib. ReadOnly}
 Reset(b);
 ss:=h4(0);
 if (c4[1]='R') and (c4[2]='I') and (c4[3]='F') and (c4[4]='F') then begin
  writeln('Est` zagolowok RIFF.');
 end else begin
  writeln(obrc(b4[1]),obrc(b4[2]),obrc(b4[3]),obrc(b4[4]),' - ne RIFF.'); halt;
 end;
 ppp:=h4(4);
 if ppp+8<>filesize(b) then begin
  writeln('Osh.: dolzh. byt` ppp+8=filesize.');
 end else begin
  writeln('Dlina fajla w norme.');
 end;
 ss:=h4(8);
 if (c4[1]='W') and (c4[2]='A') and (c4[3]='V') and (c4[4]='E') then begin
  writeln('Est` zagolowok WAVE.');
 end else begin
  writeln(obrc(b4[1]),obrc(b4[2]),obrc(b4[3]),obrc(b4[4]),' - ne WAVE.'); halt;
 end;
 {-----}
 ppp:=12;
 while not eof(b) do begin
  writeln('-----\');
  ppp0:=ppp;
  if filesize(b)-ppp=1 then begin
   read(b,n1); writeln('bajt w konce: ',n1); goto ende;
  end;
  ss:=h4(ppp);
  write(obrc(b4[1]),obrc(b4[2]),obrc(b4[3]),obrc(b4[4]),' ',sl(ss));
  sss:=h4(ppp+4); ppp:=ppp+8+sss; writeln(' ',sss:8,' ',ppp:8);
  if c4=s_fmt then show_fmt(ppp0)
  else if c4=s_fact then show_fact(ppp0)
  else if c4=s_data then show_data(ppp0)
  else show_xxx(ppp0);
  ust0(ppp);
  ende:
  writeln('-----/');
 end;
 writeln('Konec.');
  writeln('-------------');
End.
